package de.moritzruth.dracula_musical.act

import de.moritzruth.dracula_musical.device.*
import de.moritzruth.dracula_musical.song.songDuettDraculaMina
import de.moritzruth.dracula_musical.song.songMaskenball
import de.moritzruth.dracula_musical.song.songRepriseMaskenball
import de.moritzruth.theaterdsl.show.ShowBuilderContext
import de.moritzruth.theaterdsl.show.StepCue
import de.moritzruth.theaterdsl.value.percent
import kotlin.time.Duration.Companion.seconds

fun ShowBuilderContext.act2() = act("Zweiter Akt") {
    scene("Maskenball") {
        songMaskenball()

        step(StepCue.Text("Van Helsing", "Na dann, gute Nacht.")) {
            actors {
                -"Van Helsing / durch Mitte"
                -"Dr. Sewart / durch Mitte"
                +"Dracula / durch Mitte"
                +"Jonathan / durch Mitte"
            }
        }

        step(StepCue.Text("Hawkins", "Geil!")) {
            actors {
                -"Hawkins / nach links"
            }
        }

        step(StepCue.Text("Ascot", "Bringen Sie Mister Harker zur Tür!")) {
            actors {
                -"Jonathan / durch Mitte"
                -"Ascot / durch Mitte"
                -"Oberschwester / durch Mitte"
                -"Lucy / durch Mitte"
            }
        }
    }

    scene("Tanz mit einem Vampir") {
        songDuettDraculaMina()

        step(StepCue.Text("Ascot", "Mina präsentiert Dracula ihren Hals")) {
            actors {
                +"Ascot / durch Mitte"
                +"Oberschwester / durch Mitte"
                +"Lucy / durch Mitte"
            }

            onRun {
                Washs.both { it.brightness.off(0.4.seconds) }
                backlightBar.brightness.off(0.4.seconds)
                sidelight.brightness.off(0.4.seconds)
                FrontLights.all { it.brightness.fade(100.percent, 3.seconds) }
            }
        }

        step(StepCue.Text("Ascot", "Oberschwester!")) {
            actors {
                -"Ascot / durch Mitte"
                -"Oberschwester / durch Mitte"
                -"Mina / durch Mitte"
            }

            onRun {
                FrontLights.all { it.brightness.fade(40.percent, 20.seconds) }
            }
        }

        step(StepCue.Text("Dracula", "Darf ich bitten?")) {
            actors {
                -"Dracula / durch Mitte"
                -"Lucy / durch Mitte"
            }
        }

        songRepriseMaskenball()
    }

    scene("Van Helsing") {
        step(StepCue.Text("Tante 1", "Verhungert!")) {
            actors {
                +"Hawkins / durch Mitte"
                +"Dr. Sewart / durch Mitte"
                +"Van Helsing / durch Mitte"
            }
        }

        step(StepCue.Text("Van Helsing", "Alle raus, habe ich gesagt!")) {
            actors {
                -"Besucher des Maskenballs / durch Mitte"
                -"Kaffeetanten / durch Mitte"
                -"Hawkins / durch Mitte"
            }
        }

        lightStep(StepCue.Custom("Lucy bedroht Dr. Sewart (mit Musik)")) {
            BlinderBars.all {
                it.brightness.fade(100.percent, 2.seconds)
                it.preset.static(StairvilleSplb.Preset.STUB)  // switching, hectic
                it.presetSpeed.static(100.percent)
            }
        }
    }
}