package de.moritzruth.theaterdsl.dmx

import de.moritzruth.theaterdsl.value.Percentage
import kotlin.math.roundToInt

@JvmInline
value class DmxValue(val value: UByte) : Comparable<UByte> {
    companion object {
        val VALUE_RANGE = 0u..255u
    }

    override fun compareTo(other: UByte): Int = value.compareTo(other)
}

fun Percentage.toDmxValue(outputRangeStart: UByte = 0u, outputRangeEnd: UByte = 255u): DmxValue =
    DmxValue(((value * (outputRangeEnd - outputRangeStart).toDouble()).roundToInt() + outputRangeStart.toInt()).toUByte())