package de.moritzruth.theaterdsl.util

import kotlinx.serialization.Serializable

/**
 * A string which has optional additional details separated by " / "
 */
@JvmInline
@Serializable
value class StringWithDetails(val value: String) {
    companion object {
        const val DELIMITER = " / "
    }

    val main get() = value.split(DELIMITER)[0]
    val details: String? get() = value.split(DELIMITER, limit = 2).takeIf { it.size == 2 }?.let { it[1] }
    val hasDetails get() = details !== null
}