import "virtual:windi.css"
import { createApp } from "vue"
import { createRouter, createWebHistory, RouteRecordRaw } from "vue-router"
import App from "./App.vue"
import originalRoutes from "~pages"

const routes = originalRoutes.map(route => {
  if (typeof route.component !== "function") return route
  return {
    ...route,
    props: false
  }
}) as RouteRecordRaw[]

const router = createRouter({
  routes,
  history: createWebHistory()
})

const app = createApp(App)
app.use(router)
app.mount("#app")
