import { defineConfig, splitVendorChunkPlugin } from "vite"
import vuePlugin from "@vitejs/plugin-vue"
import windicssPlugin from "vite-plugin-windicss"
import pagesPlugin from "vite-plugin-pages"
import iconsPlugin from "unplugin-icons/vite"

export default defineConfig({
  plugins: [
    splitVendorChunkPlugin(),
    vuePlugin(),
    pagesPlugin({
      importMode: "sync"
    }),
    windicssPlugin(),
    iconsPlugin()
  ],
  server: {
    proxy: {
      "/api": {
        target: "http://localhost:8000",
        ws: true
      }
    }
  },
  build: {
    reportCompressedSize: false
  }
})
